Index: contrib/ntp/tests/libntp/calendar.c
===================================================================
--- contrib/ntp/tests/libntp/calendar.c	(版本 309693)
+++ contrib/ntp/tests/libntp/calendar.c	(版本 310419)
@@ -2,6 +2,7 @@
 
 #include "ntp_stdlib.h" /* test fail without this include, for some reason */
 #include "ntp_calendar.h"
+#include "ntp_unixtime.h"
 #include "unity.h"
 
 #include <string.h>
@@ -19,6 +20,7 @@
 char *	DateFromIsoToString(const struct isodate *iso);
 int	IsEqualDateCal(const struct calendar *expected, const struct calendar *actual);
 int	IsEqualDateIso(const struct isodate *expected, const struct isodate *actual);
+
 void	test_DaySplitMerge(void);
 void	test_SplitYearDays1(void);
 void	test_SplitYearDays2(void);
@@ -35,6 +37,8 @@
 void	test_IsoCalWeeksToYearEnd(void);
 void	test_DaySecToDate(void);
 
+void	test_NtpToNtp(void);
+void	test_NtpToTime(void);
 
 void
 setUp(void)
@@ -608,3 +612,126 @@
 
 	return;
 }
+
+/* --------------------------------------------------------------------
+ * unfolding of (truncated) NTP time stamps to full 64bit values.
+ *
+ * Note: These tests need a 64bit time_t to be useful.
+ */
+
+void
+test_NtpToNtp(void)
+{
+#   if SIZEOF_TIME_T <= 4
+	
+	TEST_IGNORE_MESSAGE("test only useful for sizeof(time_t) > 4, skipped");
+
+#   else
+	
+	static const uint32_t ntp_vals[6] = {
+		UINT32_C(0x00000000),
+		UINT32_C(0x00000001),
+		UINT32_C(0x7FFFFFFF),
+		UINT32_C(0x80000000),
+		UINT32_C(0x80000001),
+		UINT32_C(0xFFFFFFFF)
+	};
+
+	static char	lbuf[128];
+	vint64		hold;
+	time_t		pivot, texp, diff;
+	int		loops, iloop;
+	
+	pivot = 0;
+	for (loops = 0; loops < 16; ++loops) {
+		for (iloop = 0; iloop < 6; ++iloop) {
+			hold = ntpcal_ntp_to_ntp(
+				ntp_vals[iloop], &pivot);
+			texp = vint64_to_time(&hold);
+
+			/* constraint 1: texp must be in the
+			 * (right-open) intervall [p-(2^31), p+(2^31)[,
+			 * but the pivot 'p' must be taken in full NTP
+			 * time scale!
+			 */
+			diff = texp - (pivot + JAN_1970);
+			snprintf(lbuf, sizeof(lbuf),
+				 "bounds check: piv=%lld exp=%lld dif=%lld",
+				 (long long)pivot,
+				 (long long)texp,
+				 (long long)diff);
+			TEST_ASSERT_MESSAGE((diff >= INT32_MIN) && (diff <= INT32_MAX),
+					    lbuf);
+
+			/* constraint 2: low word must be equal to
+			 * input
+			 */
+			snprintf(lbuf, sizeof(lbuf),
+				 "low check: ntp(in)=$%08lu ntp(out[0:31])=$%08lu",
+				 (unsigned long)ntp_vals[iloop],
+				 (unsigned long)hold.D_s.lo);
+			TEST_ASSERT_EQUAL_MESSAGE(ntp_vals[iloop], hold.D_s.lo, lbuf);
+		}
+		pivot += 0x20000000;
+	}
+#   endif
+}
+
+void
+test_NtpToTime(void)
+{
+#   if SIZEOF_TIME_T <= 4
+	
+	TEST_IGNORE_MESSAGE("test only useful for sizeof(time_t) > 4, skipped");
+	
+#   else
+	
+	static const uint32_t ntp_vals[6] = {
+		UINT32_C(0x00000000),
+		UINT32_C(0x00000001),
+		UINT32_C(0x7FFFFFFF),
+		UINT32_C(0x80000000),
+		UINT32_C(0x80000001),
+		UINT32_C(0xFFFFFFFF)
+	};
+
+	static char	lbuf[128];
+	vint64		hold;
+	time_t		pivot, texp, diff;
+	uint32_t	back;
+	int		loops, iloop;
+	
+	pivot = 0;
+	for (loops = 0; loops < 16; ++loops) {
+		for (iloop = 0; iloop < 6; ++iloop) {
+			hold = ntpcal_ntp_to_time(
+				ntp_vals[iloop], &pivot);
+			texp = vint64_to_time(&hold);
+
+			/* constraint 1: texp must be in the
+			 * (right-open) intervall [p-(2^31), p+(2^31)[
+			 */
+			diff = texp - pivot;
+			snprintf(lbuf, sizeof(lbuf),
+				 "bounds check: piv=%lld exp=%lld dif=%lld",
+				 (long long)pivot,
+				 (long long)texp,
+				 (long long)diff);
+			TEST_ASSERT_MESSAGE((diff >= INT32_MIN) && (diff <= INT32_MAX),
+					    lbuf);
+
+			/* constraint 2: conversion from full time back
+			 * to truncated NTP time must yield same result
+			 * as input.
+			*/
+			back = (uint32_t)texp + JAN_1970;
+			snprintf(lbuf, sizeof(lbuf),
+				 "modulo check: ntp(in)=$%08lu ntp(out)=$%08lu",
+				 (unsigned long)ntp_vals[iloop],
+				 (unsigned long)back);
+			TEST_ASSERT_EQUAL_MESSAGE(ntp_vals[iloop], back, lbuf);
+		}
+		pivot += 0x20000000;
+	}
+#   endif
+}
Index: contrib/ntp/util/ntp-keygen.1ntp-keygenman
===================================================================
--- contrib/ntp/util/ntp-keygen.1ntp-keygenman	(版本 309693)
+++ contrib/ntp/util/ntp-keygen.1ntp-keygenman	(版本 310419)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH ntp-keygen 1ntp-keygenman "02 Jun 2016" "ntp (4.2.8p8)" "User Commands"
+.TH ntp-keygen 1ntp-keygenman "21 Nov 2016" "ntp (4.2.8p9)" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-.JaGB0/ag-lKayA0)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-psaWZm/ag-DsaOYm)
 .\"
-.\" It has been AutoGen-ed June 2, 2016 at 07:39:36 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed November 21, 2016 at 08:03:41 AM by AutoGen 5.18.5
 .\" From the definitions ntp-keygen-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
Index: contrib/ntp/util/ntp-keygen.man.in
===================================================================
--- contrib/ntp/util/ntp-keygen.man.in	(版本 309693)
+++ contrib/ntp/util/ntp-keygen.man.in	(版本 310419)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH ntp-keygen @NTP_KEYGEN_MS@ "02 Jun 2016" "ntp (4.2.8p8)" "User Commands"
+.TH ntp-keygen @NTP_KEYGEN_MS@ "21 Nov 2016" "ntp (4.2.8p9)" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-.JaGB0/ag-lKayA0)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-psaWZm/ag-DsaOYm)
 .\"
-.\" It has been AutoGen-ed June 2, 2016 at 07:39:36 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed November 21, 2016 at 08:03:41 AM by AutoGen 5.18.5
 .\" From the definitions ntp-keygen-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
Index: usr.sbin/ntp/scripts/mkver
===================================================================
--- usr.sbin/ntp/scripts/mkver	(版本 309693)
+++ usr.sbin/ntp/scripts/mkver	(版本 310419)
@@ -6,7 +6,7 @@
 
 ConfStr="$PROG"
 
-ConfStr="$ConfStr 4.2.8p8"
+ConfStr="$ConfStr 4.2.8p9"
 
 case "$CSET" in
  '') ;;
Index: contrib/ntp/sntp/sntp.man.in
===================================================================
--- contrib/ntp/sntp/sntp.man.in	(版本 309693)
+++ contrib/ntp/sntp/sntp.man.in	(版本 310419)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH sntp @SNTP_MS@ "02 Jun 2016" "4.2.8p8" "User Commands"
+.TH sntp @SNTP_MS@ "21 Nov 2016" "4.2.8p9" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-5CayKq/ag-fDaqJq)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-Mfai12/ag-0faa02)
 .\"
-.\" It has been AutoGen-ed June 2, 2016 at 07:19:39 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed November 21, 2016 at 07:58:25 AM by AutoGen 5.18.5
 .\" From the definitions sntp-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
Index: contrib/ntp/sntp/unity/Makefile.am
===================================================================
--- contrib/ntp/sntp/unity/Makefile.am	(版本 309693)
+++ contrib/ntp/sntp/unity/Makefile.am	(版本 310419)
@@ -12,6 +12,8 @@
 libunity_a_SOURCES =				\
 	../libpkgver/colcomp.c			\
 	unity.c					\
+	ulib_setup.c				\
+	ulib_teardown.c				\
 	unity.h					\
 	unity_config.h				\
 	unity_internals.h			\
Index: contrib/ntp/sntp/unity/unity_fixture.c
===================================================================
--- contrib/ntp/sntp/unity/unity_fixture.c	(版本 309693)
+++ contrib/ntp/sntp/unity/unity_fixture.c	(版本 310419)
@@ -17,10 +17,6 @@
 
 int verbose = 0;
 
-void setUp(void);
-void tearDown(void);
-void setUp(void)    { /*does nothing*/ }
-void tearDown(void) { /*does nothing*/ }
 
 static void announceTestRun(unsigned int runNumber)
 {
Index: contrib/ntp/tests/libntp/run-calendar.c
===================================================================
--- contrib/ntp/tests/libntp/run-calendar.c	(版本 309693)
+++ contrib/ntp/tests/libntp/run-calendar.c	(版本 310419)
@@ -25,6 +25,7 @@
 #include "config.h"
 #include "ntp_stdlib.h"
 #include "ntp_calendar.h"
+#include "ntp_unixtime.h"
 #include <string.h>
 
 //=======External Functions This Runner Calls=====
@@ -45,6 +46,8 @@
 extern void test_IsoCalWeeksToYearStart(void);
 extern void test_IsoCalWeeksToYearEnd(void);
 extern void test_DaySecToDate(void);
+extern void test_NtpToNtp(void);
+extern void test_NtpToTime(void);
 
 
 //=======Test Reset Option=====
@@ -63,21 +66,23 @@
 {
   progname = argv[0];
   UnityBegin("calendar.c");
-  RUN_TEST(test_DaySplitMerge, 22);
-  RUN_TEST(test_SplitYearDays1, 23);
-  RUN_TEST(test_SplitYearDays2, 24);
-  RUN_TEST(test_RataDie1, 25);
-  RUN_TEST(test_LeapYears1, 26);
-  RUN_TEST(test_LeapYears2, 27);
-  RUN_TEST(test_RoundTripDate, 28);
-  RUN_TEST(test_RoundTripYearStart, 29);
-  RUN_TEST(test_RoundTripMonthStart, 30);
-  RUN_TEST(test_RoundTripWeekStart, 31);
-  RUN_TEST(test_RoundTripDayStart, 32);
-  RUN_TEST(test_IsoCalYearsToWeeks, 33);
-  RUN_TEST(test_IsoCalWeeksToYearStart, 34);
-  RUN_TEST(test_IsoCalWeeksToYearEnd, 35);
-  RUN_TEST(test_DaySecToDate, 36);
+  RUN_TEST(test_DaySplitMerge, 24);
+  RUN_TEST(test_SplitYearDays1, 25);
+  RUN_TEST(test_SplitYearDays2, 26);
+  RUN_TEST(test_RataDie1, 27);
+  RUN_TEST(test_LeapYears1, 28);
+  RUN_TEST(test_LeapYears2, 29);
+  RUN_TEST(test_RoundTripDate, 30);
+  RUN_TEST(test_RoundTripYearStart, 31);
+  RUN_TEST(test_RoundTripMonthStart, 32);
+  RUN_TEST(test_RoundTripWeekStart, 33);
+  RUN_TEST(test_RoundTripDayStart, 34);
+  RUN_TEST(test_IsoCalYearsToWeeks, 35);
+  RUN_TEST(test_IsoCalWeeksToYearStart, 36);
+  RUN_TEST(test_IsoCalWeeksToYearEnd, 37);
+  RUN_TEST(test_DaySecToDate, 38);
+  RUN_TEST(test_NtpToNtp, 40);
+  RUN_TEST(test_NtpToTime, 41);
 
   return (UnityEnd());
 }
Index: contrib/ntp/util/ntp-keygen.1ntp-keygenmdoc
===================================================================
--- contrib/ntp/util/ntp-keygen.1ntp-keygenmdoc	(版本 309693)
+++ contrib/ntp/util/ntp-keygen.1ntp-keygenmdoc	(版本 310419)
@@ -1,9 +1,9 @@
-.Dd June 2 2016
+.Dd November 21 2016
 .Dt NTP_KEYGEN 1ntp-keygenmdoc User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntp-keygen-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  June  2, 2016 at 07:39:43 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  November 21, 2016 at 08:03:48 AM by AutoGen 5.18.5
 .\"  From the definitions    ntp-keygen-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
Index: contrib/ntp/util/ntp-keygen.mdoc.in
===================================================================
--- contrib/ntp/util/ntp-keygen.mdoc.in	(版本 309693)
+++ contrib/ntp/util/ntp-keygen.mdoc.in	(版本 310419)
@@ -1,9 +1,9 @@
-.Dd June 2 2016
+.Dd November 21 2016
 .Dt NTP_KEYGEN @NTP_KEYGEN_MS@ User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntp-keygen-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  June  2, 2016 at 07:39:43 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  November 21, 2016 at 08:03:48 AM by AutoGen 5.18.5
 .\"  From the definitions    ntp-keygen-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
